/* Tabela TPCREDBANC: */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na coluna:
              Conta contabil: CDCONTCTBL */
/* Objetivo: Gerar um log que vai registrar na tabela Geral de Logs de Operaes as alteraes nos campos da tabela Produto listados  seguir:
            Conta contabil: CDCONTCTBL
            Historico padrao: CDHISTPADR */

CREATE OR REPLACE TRIGGER LOG_CONTCORR
AFTER DELETE OR INSERT OR UPDATE OF CDCONTCTBL,
                                    CDHISTPADR

ON TPCREDBANC FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(500);
  V_ITPESQ       VARCHAR2(40);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   V_DESC       := '';
   V_ITPESQ     := '';
   V_NMOPERADOR := '';
   V_IDTIPOOPER := '';
   NMUSUARIO(V_NMOPERADOR);

   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

   IF DELETING THEN
      V_IDTIPOOPER   := '3';
      V_ITPESQ       := :OLD.CDTPCREDBANC;
      V_DESC         := 'Codigo '       || '' || NVL(:OLD.CDTPCREDBANC,'')||' '||
                        'ContContabil ' || '' || NVL(:OLD.CDCONTCTBL,'')||' '||
                        'HistPadr '     || '' || NVL(:OLD.CDHISTPADR,'');
   ELSE
      IF UPDATING THEN
         V_DESC         := 'Codigo '       || '' || NVL(:NEW.CDTPCREDBANC,'')||' '||
                           'ContContabil ' || '' || NVL(:NEW.CDCONTCTBL,'')||' '||
                           'HistPadr '     || '' || NVL(:NEW.CDHISTPADR,'');
         V_ITPESQ := :NEW.CDTPCREDBANC;
         V_IDTIPOOPER := '2';
      ELSE
         V_IDTIPOOPER   := '1';
         V_ITPESQ       := :NEW.CDTPCREDBANC;
         V_DESC         := 'Codigo '       || '' || NVL(:NEW.CDTPCREDBANC,'')||' '||
                           'ContContabil ' || '' || NVL(:NEW.CDCONTCTBL,'')||' '||
                           'HistPadr '     || '' || NVL(:NEW.CDHISTPADR,'');
      END IF;
  END IF;
   V_DESC := SUBSTR(V_DESC, 1, 300);
   INSERT INTO LOGOPERA
      (NMTABELA,
       DTOPERACAO,
       NMRESPOPER,
       IDTIPOOPER,
       DSOPERACAO,
       CDPESQITEM,
       DSRDMUSUOPER,
       DSENDUSUOPER,
       DSNMUSUOPER,
       DSMETUSUOPER,
       CDORESPOPER)
   VALUES
      ('TPCREDBANC',
       SYSDATE,
       NVL(V_NMOPERADOR,' '),
       V_IDTIPOOPER,
       V_DESC,
       V_ITPESQ,
       V_DSSERVERRDM,
       V_DSREMOTEADDR,
       V_DSREMOTEHOST,
       V_DSSERVMETHOD,
       V_DSREMOTEOPER);
END;
/


-- VERSAO --
BEGIN ATUVEROBJ('LOG_CONTCORR','4.09.091'); END;
/
