/* Sistemas Integrados TECNISA

Nome: 9816_QPRTRGO_LOG_QPR_PARAMETROQPR.SQL

Descrio:
   Trigger para gravar o log das alteraes

Criao:
   14/01/2016 - Jurandir Junio
*/

/* Tabela PARAMETROQPR.*/
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir das alteraes na tabela
              PARAMETROQPR, para verifio de erros */
CREATE OR REPLACE TRIGGER LOG_QPR_PARAMETROQPR
AFTER DELETE OR INSERT OR UPDATE
ON PARAMETROQPR FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(2000);
  V_ITPESQ       VARCHAR2(80);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
  V_CDFILLOGOPER VARCHAR2(4);
  V_TAM          INTEGER;
BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   V_DESC       := '';
   V_ITPESQ     := '';
   V_NMOPERADOR := '';
   V_IDTIPOOPER := '';
   V_CDFILLOGOPER := '';
   
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

   IF INSERTING THEN

      IF :NEW.CDFILIAL IS NOT NULL THEN
         V_DESC := V_DESC || 'CDFILIAL= ' || NVL(:NEW.CDFILIAL,'') || ' ' ;
      END IF;

      IF :NEW.NRDIAMINQUA IS NOT NULL THEN
         V_DESC := V_DESC || 'NRDIAMINQUA= ' || NVL(:NEW.NRDIAMINQUA,'') || ' ' ;
      END IF;

      IF :NEW.NRDIASVENANA IS NOT NULL THEN
         V_DESC := V_DESC || 'NRDIASVENANA= ' || NVL(:NEW.NRDIASVENANA,'') || ' ' ;
      END IF;

      IF :NEW.IDRATEIACUSTO IS NOT NULL THEN
         V_DESC := V_DESC || 'IDRATEIACUSTO= ' || NVL(:NEW.IDRATEIACUSTO,'') || ' ' ;
      END IF;

      IF :NEW.IDCONTROLOCAL IS NOT NULL THEN
         V_DESC := V_DESC || 'IDCONTROLOCAL= ' || NVL(:NEW.IDCONTROLOCAL,'') || ' ' ;
      END IF;

      IF :NEW.CDALMOXARIFE IS NOT NULL THEN
         V_DESC := V_DESC || 'CDALMOXARIFE= ' || NVL(:NEW.CDALMOXARIFE,'') || ' ' ;
      END IF;

      IF :NEW.CDLOCALESTOQ IS NOT NULL THEN
         V_DESC := V_DESC || 'CDLOCALESTOQ= ' || NVL(:NEW.CDLOCALESTOQ,'') || ' ' ;
      END IF;

      IF :NEW.IDUTSEGLIBANA IS NOT NULL THEN
         V_DESC := V_DESC || 'IDUTSEGLIBANA= ' || NVL(:NEW.IDUTSEGLIBANA,'') || ' ' ;
      END IF;

      V_ITPESQ := :NEW.CDFILIAL;

      V_IDTIPOOPER := '1';

   END IF;

   IF UPDATING THEN

      IF (:NEW.CDFILIAL <> :OLD.CDFILIAL) THEN
         V_DESC := V_DESC || 'CDFILIAL= ' || NVL(:NEW.CDFILIAL,'') || ' ' ;
      END IF;

      IF (:NEW.NRDIAMINQUA <> :OLD.NRDIAMINQUA) THEN
         V_DESC := V_DESC || 'NRDIAMINQUA= ' || NVL(:NEW.NRDIAMINQUA,'') || ' ' ;
      END IF;

      IF (:NEW.NRDIASVENANA <> :OLD.NRDIASVENANA) THEN
         V_DESC := V_DESC || 'NRDIASVENANA= ' || NVL(:NEW.NRDIASVENANA,'') || ' ' ;
      END IF;

      IF (:NEW.IDRATEIACUSTO <> :OLD.IDRATEIACUSTO) THEN
         V_DESC := V_DESC || 'IDRATEIACUSTO= ' || NVL(:NEW.IDRATEIACUSTO,'') || ' ' ;
      END IF;

      IF (:NEW.IDCONTROLOCAL <> :OLD.IDCONTROLOCAL) THEN
         V_DESC := V_DESC || 'IDCONTROLOCAL= ' || NVL(:NEW.IDCONTROLOCAL,'') || ' ' ;
      END IF;

      IF (:NEW.CDALMOXARIFE <> :OLD.CDALMOXARIFE) THEN
         V_DESC := V_DESC || 'CDALMOXARIFE= ' || NVL(:NEW.CDALMOXARIFE,'') || ' ' ;
      END IF;

      IF (:NEW.CDLOCALESTOQ <> :OLD.CDLOCALESTOQ) THEN
         V_DESC := V_DESC || 'CDLOCALESTOQ= ' || NVL(:NEW.CDLOCALESTOQ,'') || ' ' ;
      END IF;

      IF (:NEW.IDUTSEGLIBANA <> :OLD.IDUTSEGLIBANA) THEN
         V_DESC := V_DESC || 'IDUTSEGLIBANA= ' || NVL(:NEW.IDUTSEGLIBANA,'') || ' ' ;
      END IF;


      V_ITPESQ := :NEW.CDFILIAL;

      V_IDTIPOOPER := '2';

   END IF;

   IF DELETING  THEN

      IF :OLD.CDFILIAL IS NOT NULL THEN
         V_DESC := V_DESC || 'CDFILIAL= ' || NVL(:OLD.CDFILIAL,'') || ' ' ;
      END IF;

      IF :OLD.NRDIAMINQUA IS NOT NULL THEN
         V_DESC := V_DESC || 'NRDIAMINQUA= ' || NVL(:OLD.NRDIAMINQUA,'') || ' ' ;
      END IF;

      IF :OLD.NRDIASVENANA IS NOT NULL THEN
         V_DESC := V_DESC || 'NRDIASVENANA= ' || NVL(:OLD.NRDIASVENANA,'') || ' ' ;
      END IF;

      IF :OLD.IDRATEIACUSTO IS NOT NULL THEN
         V_DESC := V_DESC || 'IDRATEIACUSTO= ' || NVL(:OLD.IDRATEIACUSTO,'') || ' ' ;
      END IF;

      IF :OLD.IDCONTROLOCAL IS NOT NULL THEN
         V_DESC := V_DESC || 'IDCONTROLOCAL= ' || NVL(:OLD.IDCONTROLOCAL,'') || ' ' ;
      END IF;

      IF :OLD.CDALMOXARIFE IS NOT NULL THEN
         V_DESC := V_DESC || 'CDALMOXARIFE= ' || NVL(:OLD.CDALMOXARIFE,'') || ' ' ;
      END IF;

      IF :OLD.CDLOCALESTOQ IS NOT NULL THEN
         V_DESC := V_DESC || 'CDLOCALESTOQ= ' || NVL(:OLD.CDLOCALESTOQ,'') || ' ' ;
      END IF;

      IF :OLD.IDUTSEGLIBANA IS NOT NULL THEN
         V_DESC := V_DESC || 'IDUTSEGLIBANA= ' || NVL(:OLD.IDUTSEGLIBANA,'') || ' ' ;
      END IF;

      V_ITPESQ := :OLD.CDFILIAL;

      V_IDTIPOOPER := '3';

   END IF;

   IF NOT (V_DESC IS NULL) THEN
      V_TAM := LENGTH(V_DESC);
      WHILE (V_TAM >= 0) LOOP
         INSERT INTO LOGOPERA ( NMTABELA, DTOPERACAO, NMRESPOPER,
                                IDTIPOOPER,   DSOPERACAO, CDPESQITEM,
                                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER,
                                DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
                      VALUES  ('PARAMETROQPR', SYSDATE ,    NVL(V_NMOPERADOR,' '),
                                V_IDTIPOOPER,  SUBSTR(V_DESC,1,300), V_ITPESQ,
                                V_DSSERVERRDM, V_DSREMOTEADDR,  V_DSREMOTEHOST,
                                V_DSSERVMETHOD,   V_DSREMOTEOPER, V_CDFILLOGOPER);
         V_DESC := SUBSTR(V_DESC, 300, V_TAM);
         V_TAM := LENGTH(V_DESC);
      END LOOP;

   END IF;
END;

/
-- VERSAO --
BEGIN ATUVEROBJ('LOG_QPR_PARAMETROQPR','5.85.xxx'); END;
/
